Bug 1024368 - heat-cfntools: Use Python 3 instead of Python 2
heat-cfntools: Use Python 3 instead of Python 2
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: heat-cfntools (Show other bugs)
23
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Ryan Brown
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1194577 F23PYTHON3
  Show dependency treegraph
 
Reported: 2013-10-29 10:11 EDT by Miro Hrončok
Modified: 2016-04-26 20:16 EDT (History)
7 users (show)

See Also:
Fixed In Version: heat-cfntools-1.3.0-4.fc23.noarch.rpm
Doc Type: Enhancement
Doc Text:
Feature: Python 3 Migration Reason: Python 3 will be the system default python, and heat-cfntools needs to run on base installs of F23
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-07-15 14:05:36 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Launchpad 1347899 None None None Never

  None (edit)
Description Miro Hrončok 2013-10-29 10:11:55 EDT
Hi, we would like to use Python 3 on the default installation instead of Python 2 on Fedora 22.

https://fedoraproject.org/wiki/Changes/Python_3_as_Default

According to FESCo, we should firstly focus on the cloud image.

From that perspective, your package is considered as IMPORTANT - that means, is has to be updated to Python 3, for our intention come true.

The goal here is, that for F22 you should use Python 3 instead of Python 2 in this package.

Please, help us update to Python 3 flawlessly.

Check if upstream already support Python 3, if yes, use it and add the support to the package.

If upstream doesn't support Python 3 yet, encourage it to do so by sending patches and offering your help.

When upstream is dead or unwilling to support Python 3, say so and we can solve the problem together.

Chances are, that you ARE the upstream. In that case, everything is easier, just do it yourself.

There is a table on wiki, that should list your package. Chances are, that you can see an upstream link that covers the problem. Anyway, please update the table with information you know.

https://fedoraproject.org/wiki/User:Churchyard/python3

I offer my help with this task, so if you have no idea, how to work on this, or it is just not your priority, don't hesitate to ask for help.

(As you've already realized, this is a bulk text, so if something is not quite exact about your package, sorry for that, just ask)
Comment 1 Miro Hrončok 2014-05-30 06:52:35 EDT
Hi, any progress or at least some status on this? Thanks
Comment 2 Steven Hardy 2014-07-23 16:33:41 EDT
(In reply to Miro Hrončok from comment #1)
> Hi, any progress or at least some status on this? Thanks

I've raised an upstream bug:

https://bugs.launchpad.net/heat-cfntools/+bug/1347899

If you have bandwidth to help with a patch porting to python3 upstream, that would be great, if not I'll try to look at it at some point and update this bug when done.
Comment 3 Miro Hrončok 2014-12-16 16:55:19 EST
I'm trying to run the test suite on Py3, but there are still packages missing.
Comment 4 Miro Hrončok 2015-02-23 04:21:37 EST
Upstream now has code working on Python 3 (in git). Release should be ready soon.

Python 3 ready spec: https://github.com/fedora-python/heat-cfntools/blob/python3/heat-cfntools.spec
Comment 5 Bohuslav "Slavek" Kabrda 2015-02-23 07:25:09 EST
Ok, so it seems that we'll have to revert after all for F22 [1]. Please only build this for F23 (so this doesn't need to be built today). Thanks.

[1] https://bugzilla.redhat.com/show_bug.cgi?id=1194577#c4
Comment 6 Jaroslav Reznik 2015-03-03 12:08:02 EST
This bug appears to have been reported against 'rawhide' during the Fedora 22 development cycle.
Changing version to '22'.

More information and reason for this action is here:
https://fedoraproject.org/wiki/Fedora_Program_Management/HouseKeeping/Fedora22
Comment 7 Steve Baker 2015-05-27 17:11:14 EDT
Upstream heat-cfntools 1.3.0 has been released, which includes python 3 support.
Comment 8 Miro Hrončok 2015-05-27 17:43:54 EDT
Thanks for info and help with that.
Comment 9 Robert Kuska 2015-07-03 03:22:08 EDT
Please switch your package to use Python3, system wide change for making LiveCD Python3 only was accepted by FESCO for Fedora23.
Comment 10 Zane Bitter 2015-07-08 17:37:50 EDT
Support has been implemented upstream, so just needs packaging changes.
Comment 11 Robert Kuska 2015-07-09 03:17:38 EDT
Ryan, can you please switch the package to use Python3?
Comment 12 Miro Hrončok 2015-07-13 08:19:45 EDT
I'll prepare a patch for spec and attach it.
Comment 13 Miro Hrončok 2015-07-13 08:41:26 EDT
Oh, looking to the comments, I've already done that before. So I've rebased my patch here: https://github.com/fedora-python/heat-cfntools/commit/e680672c8b8ebd682fc120addd99f37c9eb04bb5

I've enabled the tests as well and they are passing. See a scratch build here: http://koji.fedoraproject.org/koji/taskinfo?taskID=10339644

If you agree, I can push it to Fedora.
Comment 14 Ryan Brown 2015-07-13 08:46:58 EDT
Miro: Thank you for doing that!

If it's alright with you, I'd like to make the spec work on both Python 2 and 3, I'll cherry-pick your patch and add conditionals to support either. 

Should the package to be Py3 only?
Comment 15 Miro Hrončok 2015-07-13 08:58:03 EDT
It(In reply to Ryan Brown from comment #14)
> If it's alright with you, I'd like to make the spec work on both Python 2
> and 3, I'll cherry-pick your patch and add conditionals to support either.

I think it will make the specfile a little bit less readable and less straightforward, but if it helps with your workflow, it's OK.

> Should the package to be Py3 only?

If I understand the purpose of this package right, then yes.

From what I understand, the priority of this package is the script ín /usr/bin. In that case, only one Python interpreter is necessary/useful because both variants would provide the same functionality.

If this would be a Python module/library to import from other tools, then having both packages would make sense (so other tools could grab the version they need).

Is the heat_cfntools module intended to be imported form other Python tools? I thought not, but maybe I'm wrong. No other packages depend on this BTW.
Comment 16 Ryan Brown 2015-07-13 09:27:59 EDT
You're right, heat-cfntools isn't imported as a library by anything I'm aware of.

I'll get that update out today, thanks again!
Comment 17 Miro Hrončok 2015-07-14 06:49:29 EDT
I see it in packages git and in Koji. Should we close this?
Comment 18 Ryan Brown 2015-07-14 08:43:05 EDT
Not yet, it hasn't moved into the rawhide repo. I'll close it when it's available.
Comment 19 Miro Hrončok 2015-07-14 08:45:15 EDT
ok, thanks
Comment 20 Jan Kurik 2015-07-15 10:44:26 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 23 development cycle.
Changing version to '23'.

(As we did not run this process for some time, it could affect also pre-Fedora 23 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 23 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora23

Note You need to log in before you can comment on or make changes to this bug.